//
// Created by william on 5/17/24.
//

#include <stdbool.h>
#include "../include/types.h"

#ifndef NES_EMULATOR_MEMORY_H
#define NES_EMULATOR_MEMORY_H

typedef struct ppu_vram_fetch {
    vram *vram;
    byte data;
    bool finished;
} PPUVramFetch;

typedef struct ppu_tile_fetch {
    byte nametable;
    byte attribute_table;
    byte pattern_table_tile_low;
    byte pattern_table_tile_high;
} PPUTileFetch;

void ppu_vram_fetch(PPUVramFetch *fetch, address addr);

void ppu_tile_fetch(PPUTileFetch *fetch, address addr);

#endif //NES_EMULATOR_MEMORY_H
